=== debian/changelog ===
mysql-connector-c++ (1.1.7-3) unstable; urgency=medium

  * Upload to unstable (Closes: #841585).
  * Merged changelog history.
  * Build with "default-libmysqlclient-dev".
  * New patches for compatibility with MariaDB:
    + mariadb_api.patch
    + no-MYSQL_TYPE_JSON.patch
  * debhelper style rules; parallel build; "bindnow" hardening.
  * Added:
    + Homepage.
    + Vcs links.
    + "gbp.conf".
    + patch headers.
    + myself to Uploaders.
  * Standards-Version: 3.9.8.
  * New "watch" file; check upstream signature.
  * Updated copyright and converted it to copyright format 1.0.
  * lintian-override for "license-problem-non-free-RFC" false-positive.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 13 Nov 2016 20:29:17 +1100

mysql-connector-c++ (1.1.7-2) experimental; urgency=medium

  * remove -DCMAKE_INSTALL_LIBDIR=lib and multiarchify

 -- Rene Engelhard <rene@debian.org>  Mon, 05 Sep 2016 13:06:00 +0000

mysql-connector-c++ (1.1.7-1) experimental; urgency=medium

  * New upstream release

  * use dh_* -a instead of -s

 -- Rene Engelhard <rene@debian.org>  Wed, 16 Mar 2016 18:24:41 +0100

mysql-connector-c++ (1.1.6-2) experimental; urgency=medium

  * remove mysql_config hack again and properly build-depend on
    libmysqlclient-dev (>= 5.6.27)

 -- Rene Engelhard <rene@debian.org>  Sun, 08 Nov 2015 11:35:01 +0100

mysql-connector-c++ (1.1.6-1) experimental; urgency=medium

  * New upstream release

  * fix FTBFS: use own-hacked mysql_config removing -fno-exeptions
    and -fno-rtti from cxxflags. Builds at least, no idea (yet) whether
    it will work.

  * merge from unstable:
    - libstdc++6 transition: s/libmysqlcppconn7/libmysqlcppconn7v5/

 -- Rene Engelhard <rene@debian.org>  Thu, 01 Oct 2015 16:42:45 +0200

mysql-connector-c++ (1.1.5-1) experimental; urgency=medium

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Tue, 28 Apr 2015 23:28:13 +0200

mysql-connector-c++ (1.1.4+really1.1.3-1) unstable; urgency=medium

  * revert to 1.1.3 (closes: #836731)

 -- Rene Engelhard <rene@debian.org>  Mon, 05 Sep 2016 12:50:25 +0200

mysql-connector-c++ (1.1.4-2) unstable; urgency=medium

  * (really) set -DCMAKE_INSTALL_LIBDIR=lib instead of manual mv...

 -- Rene Engelhard <rene@debian.org>  Sun, 21 Aug 2016 10:48:21 +0200

mysql-connector-c++ (1.1.4-1) unstable; urgency=medium

  * "New" upstream release

  * explicitly set INSTALL_LIBDIR to lib to fix install
  * use dh_* -a instead of -s

 -- Rene Engelhard <rene@debian.org>  Sun, 21 Aug 2016 10:16:27 +0200
