=== debian/control ===
Source: mysql-connector-c++
Section: libs
Priority: optional
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>,
 Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9), dh-exec (>= 0.3), cmake
#  ,libmysqlclient-dev (>= 5.7.8)
  ,default-libmysqlclient-dev
  ,libboost-dev
  ,libssl-dev
Standards-Version: 3.9.8
Homepage: https://dev.mysql.com/doc/relnotes/connector-cpp/en/news-1-1.html
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mysql-connector-c++.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mysql-connector-c++.git

Package: libmysqlcppconn-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libboost-dev, libmysqlcppconn7v5 (= ${binary:Version}), ${misc:Depends}
Description: MySQL Connector for C++ (development files)
 MySQL Connector/C++ is a MySQL database connector for C++.
 .
 It mimics the JDBC 4.0 API.
 .
 This package contains the development files (headers, static library).

Package: libmysqlcppconn7v5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmysqlcppconn7
Description: MySQL Connector for C++ (library)
 MySQL Connector/C++ is a MySQL database connector for C++.
 .
 It mimics the JDBC 4.0 API.
 .
 This package contains the shared library
