=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

LIBNAME=$(shell readlink -f `mysql_config --variable=pkglibdir`/libmysqlclient_r.so | sed -e s/mysqlclient/mysqlclient_r/ | sed -e "s,`mysql_config --variable=pkglibdir`/\(libmysqlclient_r.so.[0-9][0-9]\).*,\\1,")

%:
	dh $@ --parallel

override_dh_auto_configure: $(info LIBNAME=$(LIBNAME))
	dh_auto_configure -- \
          -DCMAKE_INSTALL_PREFIX:PATH=/usr \
          -DMYSQLCPPCONN_BUILD_EXAMPLES:BOOL=0 \
          -DMYSQLCPPCONN_ICU_ENABLE:BOOL=0 \
          -DMYSQLCLIENT_STATIC_LINKING:BOOL=0

#          -DMYSQLCLIENT_LIB_NAME=$(LIBNAME)
